%% this file performs the Wansbeek-Kapteyn transformation
% it is very time-consuming, for convenience, a copy of the output file generated by this script 
% is available in the Data/csv folder

clear all
clc
close all
addpath(genpath('~/Dropbox/Double Q Survey Replication/'))

%% load data

panel=importdata('~/Dropbox/Double Q Survey Replication/Data/csv/panel_wk.csv');

%colanmes
%("id","t","v.e","pi.e.1m.e.new","pi.e.3m.e.new","pi.e.1y.e.new",
%"v.g","pi.e.1m.g.new","pi.e.3m.g.new","pi.e.1y.g.new",
%"v.h","pi.e.1m.h.new","pi.e.3m.h.new","pi.e.1y.h.new")
%% specify variables
d=panel.data;
vars=d(:,3:end);
ids=d(:,1);
ids_u=unique(ids);
H=max(ids); % assume that all h=1,2, ... , H appear at least once
time=d(:,2);
T=max(time);
N=length(ids); % total number of observations

ih=ones(H,1); % vector of ones



%% 1. construct matrices D1, D2, ... , DT
% Dt is the HxH identity matrix with rows corresponding to missing
% households removed

D=cell(1,T);

Z1=[]; % stacks D1; D2; ... , DT
Z2=[]; % blok-diagonal with Dt*ih
for t=1:T
    
d=eye(H);
%%% vector of missing households

ids_t=ids(time==t,:); % select data from time period t
check=ismember(ids_u,ids_t);
missing=ids_u(check==0);

d(missing,:)=[];
D(t)={d};

Z1=[Z1;d];

d2=d*ih;
Z2=blkdiag(Z2,d2);

end


Z=[Z1,Z2];

DeltaH=Z1'*Z1;
DeltaT=Z2'*Z2;
A=Z2'*Z1;

temp=Z1/DeltaH;

Zbar=Z2-temp*A'; 
%Zbar=Z2-Z1*inv(DeltaH)*A';
%Zbar2=(eye(N)-Z1/DeltaH*Z1')*Z2;
 
Q=DeltaT-A/DeltaH*A';
%Q=DeltaT-A*inv(DeltaH)*A';
%Q2=Z2'*Zbar;
P1=eye(N)-temp*Z1';
P2=Zbar*inv(Q);

P=P1-P2*Zbar';


%P=eye(N)-temp*Z1'-Zbar*inv(Q)*Zbar';

%% transform data

Pvars=P*vars;
%export to csv
to_export=[ids time vars Pvars];
cd '~/Dropbox/Double Q Survey Replication/Data/csv/'
dlmwrite('WK_transformed.csv',to_export, 'precision', 9)

% save matlab data to avoid running the time-consuming WK transformation
% again
cd '~/Dropbox/Double Q Survey Replication/Data/MATLAB/'
save('WK_transformed','to_export');










